/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling two relays
	/// </summary>
	public class BrickletDualRelay : Device 
	{

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_STATE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_STATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_MONOFLOP = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_MONOFLOP = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_MONOFLOP_DONE = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		///  This callback is triggered whenever a monoflop timer reaches 0. The 
		///  parameter contain the relay (1 or 2) and the current state of the relay 
		///  (the state after the monoflop).
		///  
		///  .. versionadded:: 1.1.1~(Plugin)
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDone;
		public delegate void MonoflopDoneEventHandler(object sender, byte relay, bool state);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletDualRelay(string uid, IPConnection ipcon) : base(uid, ipcon) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 1;
			messageCallbacks[CALLBACK_MONOFLOP_DONE] = new MessageCallback(OnMonoflopDone);

			responseExpected[FUNCTION_SET_STATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MONOFLOP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MONOFLOP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_MONOFLOP_DONE] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Sets the state of the relays, *true* means on and *false* means off. 
		///  For example: (true, false) turns relay 1 on and relay 2 off.
		///  
		///  If you just want to set one of the relays and don't know the current state
		///  of the other relay, you can get the state with <see cref="Tinkerforge.BrickletDualRelay.GetState"/>.
		///  
		///  Running monoflop timers will be overwritten if this function is called.
		///  
		///  The default value is (*false*, *false*).
		/// </summary>
		public void SetState(bool relay1, bool relay2)
		{
			byte[] data_ = MakePacketHeader(10, FUNCTION_SET_STATE);
			LEConverter.To((bool)relay1, 8, data_);
			LEConverter.To((bool)relay2, 9, data_);

			if(responseExpected[FUNCTION_SET_STATE] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_STATE] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_STATE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the state of the relays, *true* means on and *false* means off.
		/// </summary>
		public void GetState(out bool relay1, out bool relay2)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_STATE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_STATE, out response);

			relay1 = LEConverter.BoolFrom(8, response);
			relay2 = LEConverter.BoolFrom(9, response);
		}

		/// <summary>
		///  The first parameter can be 1 or 2 (relay 1 or relay 2). The second parameter 
		///  is the desired state of the relay (*true* means on and *false* means off).
		///  The third parameter indicates the time (in ms) that the relay should hold 
		///  the state.
		///  
		///  If this function is called with the parameters (1, true, 1500):
		///  Relay 1 will turn on and in 1.5s it will turn off again.
		///  
		///  A monoflop can be used as a failsafe mechanism. For example: Lets assume you 
		///  have a RS485 bus and a Dual Relay Bricklet connected to one of the slave 
		///  stacks. You can now call this function every second, with a time parameter
		///  of two seconds. The relay will be on all the time. If now the RS485 
		///  connection is lost, the relay will turn off in at most two seconds.
		///  
		///  .. versionadded:: 1.1.1~(Plugin)
		/// </summary>
		public void SetMonoflop(byte relay, bool state, long time)
		{
			byte[] data_ = MakePacketHeader(14, FUNCTION_SET_MONOFLOP);
			LEConverter.To((byte)relay, 8, data_);
			LEConverter.To((bool)state, 9, data_);
			LEConverter.To((int)time, 10, data_);

			if(responseExpected[FUNCTION_SET_MONOFLOP] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_MONOFLOP] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_MONOFLOP, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns (for the given relay) the current state and the time as set by 
		///  <see cref="Tinkerforge.BrickletDualRelay.SetMonoflop"/> as well as the remaining time until the state flips.
		///  
		///  If the timer is not running currently, the remaining time will be returned
		///  as 0.
		///  
		///  .. versionadded:: 1.1.1~(Plugin)
		/// </summary>
		public void GetMonoflop(byte relay, out bool state, out long time, out long timeRemaining)
		{
			byte[] data_ = MakePacketHeader(9, FUNCTION_GET_MONOFLOP);
			LEConverter.To((byte)relay, 8, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_MONOFLOP, out response);

			state = LEConverter.BoolFrom(8, response);
			time = LEConverter.UIntFrom(9, response);
			timeRemaining = LEConverter.UIntFrom(13, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers are:
		///  
		///  <code>
		///   "Device Identifier", "Device"
		///  
		///   "11", "Brick DC"
		///   "12", "Brick Debug"
		///   "13", "Brick Master 2.0"
		///   "14", "Brick Servo"
		///   "15", "Brick Stepper"
		///   "16", "Brick IMU"
		///   "", ""
		///   "21", "Bricklet Ambient Light"
		///   "22", "Bricklet Breakout"
		///   "23", "Bricklet Current12"
		///   "24", "Bricklet Current25"
		///   "25", "Bricklet Distance IR"
		///   "26", "Bricklet Dual Relay"
		///   "27", "Bricklet Humidity"
		///   "28", "Bricklet IO-16"
		///   "29", "Bricklet IO-4"
		///   "210", "Bricklet Joystick"
		///   "211", "Bricklet LCD 16x2"
		///   "212", "Bricklet LCD 20x4"
		///   "213", "Bricklet Linear Poti"
		///   "214", "Bricklet Piezo Buzzer"
		///   "215", "Bricklet Rotary Poti"
		///   "216", "Bricklet Temperature"
		///   "217", "Bricklet Temperature IR"
		///   "218", "Bricklet Voltage"
		///   "219", "Bricklet Analog In"
		///   "220", "Bricklet Analog Out"
		///   "221", "Bricklet Barometer"
		///   "222", "Bricklet GPS"
		///   "223", "Bricklet Industrial Digital In 4"
		///   "224", "Bricklet Industrial Digital Out 4"
		///   "225", "Bricklet Industrial Quad Relay"
		///   "226", "Bricklet PTC"
		///   "227", "Bricklet Voltage/Current"
		///  </code>
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnMonoflopDone(byte[] data_)
		{
			byte relay = LEConverter.ByteFrom(8, data_);
			bool state = LEConverter.BoolFrom(9, data_);

			var handler = MonoflopDone;
			if(handler != null)
			{
				handler(this, relay, state);
			}
		}
	}
}